## lua-torch-nn 0~20171002

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)
CMAKE_POLICY(VERSION 2.6)

FIND_PACKAGE(Torch REQUIRED)

ADD_SUBDIRECTORY(lib)

FILE(STRINGS lib/THNN/generic/THNN.h THNN_headers NEWLINE_CONSUME)
FILE(WRITE THNN_h.lua "return [[")
FILE(APPEND THNN_h.lua ${THNN_headers})
FILE(APPEND THNN_h.lua "]]")

FILE(GLOB luasrc *.lua)

ADD_TORCH_PACKAGE(nn "" "${luasrc}")

INSTALL(DIRECTORY "doc" DESTINATION "${Torch_INSTALL_LUA_PATH_SUBDIR}/nn")
INSTALL(FILES "README.md" DESTINATION "${Torch_INSTALL_LUA_PATH_SUBDIR}/nn")

=== lib/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)
CMAKE_POLICY(VERSION 2.6)
SET(THNN_INSTALL_LIB_SUBDIR "${Torch_INSTALL_LUA_CPATH_SUBDIR}")
SET(THNN_INSTALL_INCLUDE_SUBDIR "${Torch_INSTALL_INCLUDE_SUBDIR}")
ADD_SUBDIRECTORY(THNN)

=== lib/THNN/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)
CMAKE_POLICY(VERSION 2.6)

IF(NOT Torch_FOUND)
  FIND_PACKAGE(Torch REQUIRED)
ENDIF()

IF(NOT TH_LIBRARIES)
  SET(TH_LIBRARIES "TH")
ENDIF(NOT TH_LIBRARIES)
MESSAGE(STATUS "TH_LIBRARIES: ${TH_LIBRARIES}")

IF(NOT THNN_INSTALL_LIB_SUBDIR)
  SET(THNN_INSTALL_LIB_SUBDIR "lib" CACHE PATH "THNN install library directory")
  SET(THNN_INSTALL_INCLUDE_SUBDIR "include" CACHE PATH "THNN install include subdirectory")
ENDIF()

# Flags
# When using MSVC
IF(MSVC)
  # we want to respect the standard, and we are bored of those **** .
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE=1)
  ADD_DEFINITIONS(-DTH_EXPORTS)
ENDIF(MSVC)

IF (CMAKE_VERSION VERSION_LESS "3.1")
  SET(CMAKE_C_FLAGS "-std=c99 ${CMAKE_C_FLAGS}")
ELSE ()
  SET(CMAKE_C_STANDARD 99)
ENDIF ()

# OpenMP support?
SET(WITH_OPENMP ON CACHE BOOL "OpenMP support if available?")
IF (APPLE AND CMAKE_COMPILER_IS_GNUCC)
  EXEC_PROGRAM (uname ARGS -v  OUTPUT_VARIABLE DARWIN_VERSION)
  STRING (REGEX MATCH "[0-9]+" DARWIN_VERSION ${DARWIN_VERSION})
  MESSAGE (STATUS "MAC OS Darwin Version: ${DARWIN_VERSION}")
  IF (DARWIN_VERSION GREATER 9)
    SET(APPLE_OPENMP_SUCKS 1)
  ENDIF (DARWIN_VERSION GREATER 9)
  EXECUTE_PROCESS (COMMAND ${CMAKE_C_COMPILER} -dumpversion
    OUTPUT_VARIABLE GCC_VERSION)
  IF (APPLE_OPENMP_SUCKS AND GCC_VERSION VERSION_LESS 4.6.2)
    MESSAGE(STATUS "Warning: Disabling OpenMP (unstable with this version of GCC)")
    MESSAGE(STATUS " Install GCC >= 4.6.2 or change your OS to enable OpenMP")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unknown-pragmas")
    SET(WITH_OPENMP OFF CACHE BOOL "OpenMP support if available?" FORCE)
  ENDIF ()
ENDIF ()

IF (WITH_OPENMP)
  FIND_PACKAGE(OpenMP)
  IF(OPENMP_FOUND)
    MESSAGE(STATUS "Compiling with OpenMP support")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
  ENDIF(OPENMP_FOUND)
ENDIF (WITH_OPENMP)

LINK_DIRECTORIES("${Torch_INSTALL_LIB}")

SET(src init.c)
ADD_LIBRARY(THNN MODULE init.c)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
### Torch packages supposes libraries prefix is "lib"
SET_TARGET_PROPERTIES(THNN PROPERTIES
  PREFIX "lib"
  IMPORT_PREFIX "lib")

TARGET_LINK_LIBRARIES(THNN ${TH_LIBRARIES})

# Luarocks bug pre-14.04 prevents us from setting it for Lua-Torch
IF(THNN_SO_VERSION)
  MESSAGE(STATUS "THNN_SO_VERSION: ${THNN_SO_VERSION}")
  SET_TARGET_PROPERTIES(THNN PROPERTIES
    VERSION   ${THNN_SO_VERSION}
    SOVERSION ${THNN_SO_VERSION})
ENDIF(THNN_SO_VERSION)

INSTALL(TARGETS THNN LIBRARY DESTINATION ${THNN_INSTALL_LIB_SUBDIR})
INSTALL(FILES THNN.h DESTINATION "${THNN_INSTALL_INCLUDE_SUBDIR}/THNN")
INSTALL(FILES generic/THNN.h DESTINATION "${THNN_INSTALL_INCLUDE_SUBDIR}/THNN/generic")

## lua-torch-nn 0~20171002-g8726825+dfsg

=== debian/changelog ===
lua-torch-nn (0~20171002-g8726825+dfsg-4) unstable; urgency=medium

  * Add new include path due to lua-torch-torch7's header path move.
    (Closes: #908657)
  * Bump Standards-Version to 4.2.1 (no change).
  * Modify test.lua to adapt to lua-moses' API change. (Closes: #907791)
    + debian/patches/lua-moses-2.0.0.patch
  * Require lua-moses (>= 2.0.0~) as both Build-Depends and Depends.

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 12 Sep 2018 10:09:08 +0000

lua-torch-nn (0~20171002-g8726825+dfsg-3) unstable; urgency=medium

  * Enable i386 build.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 12 May 2018 08:53:52 +0000

lua-torch-nn (0~20171002-g8726825+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 29 Apr 2018 14:55:38 +0000

lua-torch-nn (0~20171002-g8726825+dfsg-1) experimental; urgency=medium

  * New upstream version 0~20171002-g8726825+dfsg
  * Add watch to monitor upstream master branch.
  * Bump debhelper compat level to 11.
    + Remove --parallel argument to dh since it's the default for compat 11.
  * Update copyright information.
  * Point Vcs-* fields to Salsa.
  * Add lua-moses as new Depends. (Closes: #870029)
  * Fix broken symlink by linking to the actual shared lib instead.
    (Closes: #876708)
  * Bump Standards-Version to 4.1.4 (no change).
    + Change URLs in copyright into https form.
  * Refresh symbols control file for libtorch-thnn.
  * List the removed files in copyright instead of README.Source
  * Let the dh_auto_test target check DEB_BUILD_OPTIONS.
  * Don't manually set DEB_HOST_MULTIARCH in rules.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 26 Apr 2018 09:14:00 +0000

lua-torch-nn (0~20170726-gf613412+dfsg-1) experimental; urgency=medium

  * New upstream version 0~20170726-gf613412+dfsg
  * control: Bump Standards-Version to 4.0.0 (requires no change).
  * symbols: refresh
  * tests: Update autopkgtest.

 -- Zhou Mo <cdluminate@gmail.com>  Wed, 26 Jul 2017 16:06:57 +0000

lua-torch-nn (0~20170521-g84b4350+dfsg-1) experimental; urgency=medium

  * Import upstream snapshot.
  * Only build on architectures supported by upstream.
    Supported: amd64 arm64 armel armhf ppc64el kfreebsd-amd64
  * Temporarily allow upstream unittest to fail via rules.
  * Refresh symbols control file.

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 22 May 2017 03:47:25 +0000

lua-torch-nn (0~20170308-g1d38cba+dfsg-1) experimental; urgency=medium

  * Import upstream snapshot.
  * Refresh symbols control file.

 -- Zhou Mo <cdluminate@gmail.com>  Tue, 14 Mar 2017 11:02:59 +0000

lua-torch-nn (0~20170204-g3a1b725+dfsg-1) experimental; urgency=medium

  * Import upstream snapshot.
  * Refresh patche: THNN-cmake-add-soversion.
  * Modify Depends: luajit is prior to lua5.1 .
  * Refresh symbols control file.

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 06 Feb 2017 04:12:11 +0000

lua-torch-nn (0~20170104-ge77b592+dfsg-1) experimental; urgency=medium

  * Import upstream snapshot.
  * Bump debhelper compat to 10.
  * Remove patch: THNN-assume-torch-is-present . Use cmake flag
    `Torch_FOUND` in d/rules instead.
  * Modify patch: THNN-cmake-add-soversion to adapt upstream change.
  * Add basic autopkgtest support.
  * Mend a problematic comment in rules.

 -- Zhou Mo <cdluminate@gmail.com>  Wed, 11 Jan 2017 06:59:45 +0000

lua-torch-nn (0~20161116-g8e0b061+dfsg-2) experimental; urgency=medium

  * Maintainer is Debian Science Team, and put myself to Uploaders.
  * Depends on libtorch-thnn-dev instead of libtorch-thnn for lua-torch-nn,
    the library is used in the Luajit FFI manner, which requires the header.

 -- Zhou Mo <cdluminate@gmail.com>  Fri, 16 Dec 2016 01:43:22 +0000

lua-torch-nn (0~20161116-g8e0b061+dfsg-1) experimental; urgency=medium

  * New upstream snapshot.
  * Refresh symbols control file.
  * Remove -Wall -pedantic from DEB_CFLAGS_MAINT_APPEND to reduce log size.

 -- Zhou Mo <cdluminate@gmail.com>  Thu, 17 Nov 2016 10:00:19 +0000

lua-torch-nn (0~20160908-g9d7b9ea+dfsg-1) experimental; urgency=medium

  * Import upstream snapshot 9d7b9ea4c9ba38e92dc0186af33ff7c0f323d2a4.
  * Remove patch 'fix-spelling-errors' which was merged to upstream.
  * Refresh symbols control file.
  * Override lintianW: symbols-file-contains-debian-revision due to #539066.

 -- Zhou Mo <cdluminate@gmail.com>  Sat, 10 Sep 2016 02:58:02 +0000

lua-torch-nn (0~20160812-g461701f+dfsg-1) experimental; urgency=low

  * Initial release. Closes: #826794

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 06 Jun 2016 03:50:31 +0000

=== debian/control ===
Source: lua-torch-nn
Section: interpreters
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <cdluminate@gmail.com>
Build-Depends: cmake,
               debhelper (>=11),
               dh-lua,
               libtorch-th-dev,
               lua-torch-torch7,
               luajit,
               lua-moses (>= 2.0.0~),
Standards-Version: 4.2.1
Homepage: https://github.com/torch/nn
Vcs-Git: https://salsa.debian.org/science-team/lua-torch-nn.git
Vcs-Browser: https://salsa.debian.org/science-team/lua-torch-nn

# Architecture Note:
# https://github.com/torch/torch7/issues/762#issuecomment-271497176
# supported: amd64 arm64 armel armhf ppc64el kfreebsd-amd64

Package: lua-torch-nn
Architecture: all
Depends: libtorch-thnn-dev (>= ${source:Version}),
         lua-torch-torch7,
         lua-moses (>= 2.0.0~),
         luajit | lua5.1,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: luajit
XB-Lua-Versions: ${lua:Versions}
Description: Neural Network Package for Torch Framework
 This package provides an easy and modular way to build and train
 simple or complex neural networks using Torch Framework:
 .
  * Modules are the bricks used to build neural networks.
    Each are themselves neural networks, but can be combined with
    other networks using containers to create complex neural networks:
 .
    + Module: abstract class inherited by all modules.
    + Containers: container classes.
    + Transfer functions: non-linear functions.
    + Simple layers: simple network layer like `Linear`.
    + Table layers: layers for manipulating `table`s.
    + Convolution layers: several kinds of convolutions.
 .
  * Criterions compute a gradient according to a given loss function
    given an input and a target:
 .
    + Criterions: a list of all criterions.
    + `MSECriterion`: the Mean Squared Error criterion used for regression;
    + `ClassNLLCriterion`: the Negative Log Likelihood criterion used for
      classification.
 .
  * Additional documentation:
 .
   + Overview of the package essentials including modules, containers
     and training.
   + Training: how to train a neural network using optim.
   + Testing: how to test your modules.
   + Experimental Modules: a package containing experimental modules and
     criteria.
 .
 This package is a core part of the Torch Framework.

Package: libtorch-thnn
Architecture: amd64 arm64 armel armhf ppc64el kfreebsd-amd64 i386
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: libTHNN.so of Neural Network Package for Torch Framework
 This package provides an easy and modular way to build and train
 simple or complex neural networks using Torch Framework.
 .
 This package contains libTHNN.so , backend library for lua-torch-nn.

Package: libtorch-thnn-dev
Architecture: amd64 arm64 armel armhf ppc64el kfreebsd-amd64 i386
Section: libdevel
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libtorch-thnn (= ${binary:Version})
Description: libTHNN.so of Neural Network Package for Torch Framework (dev)
 This package provides an easy and modular way to build and train
 simple or complex neural networks using Torch Framework.
 .
 This package contains headers for libTHNN.so .

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = #-Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

TMP=$(shell pwd)/debian/tmp
LUA51=/usr/bin/lua5.1
LUAJIT=/usr/bin/luajit
ROOTDIR=$(shell pwd)

TORCH_FLAGS_5_1= \
 -DLUA=/usr/bin/lua5.1 \
 -DLUA_INCDIR=/usr/include/lua5.1 \
 -DLUA_LIBDIR=/usr/lib \
 -DLUA_BINDIR=/usr/bin \
 -DLIBDIR=/usr/lib \
 -DLUALIB=lua5.1 \
 -DTorch_INSTALL_BIN_SUBDIR=bin/ \
 -DTorch_INSTALL_LIB_SUBDIR=lib/$(DEB_HOST_MULTIARCH)/ \
 -DTorch_INSTALL_INCLUDE_SUBDIR=include/ \
 -DCMAKE_VERBOSE_MAKEFILE=ON \
 -DCMAKE_BUILD_TYPE=Release \
 -DCMAKE_INSTALL_PREFIX=/usr \
 -DCMAKE_C_FLAGS="-I/usr/include/TH -I/usr/include/lua5.1/TH -g" \
 -DTorch_FOUND=ON \
 -DUSE_THNN_SO_VERSION=ON \
 -DTHNN_SO_VERSION="0"

%:
	dh $@ --buildsystem=lua --with lua

override_dh_auto_configure:
	ln -s . nn
	# generate THNN_h.lua
	set -e; mkdir build; cd build; cmake ..; cd ..; rm -rf build
	# configure libTHNN.so
	set -e; if ! test -d THNN.build; then mkdir THNN.build; fi
	set -e; cd THNN.build; cmake ../lib/THNN $(TORCH_FLAGS_5_1) \
		-DTorch_INSTALL_CMAKE_SUBDIR=/usr/share/libtorch-thnn-dev/
	# configure the rest lua stuff
	dh_auto_configure --buildsystem=lua
	# configure install template
	sed -e 's/#DEB_HOST_MULTIARCH#/$(DEB_HOST_MULTIARCH)/g' \
		< debian/libtorch-thnn.install.in > debian/libtorch-thnn.install
	sed -e 's/#DEB_HOST_MULTIARCH#/$(DEB_HOST_MULTIARCH)/g' \
		< debian/libtorch-thnn.links.in > debian/libtorch-thnn.links
	sed -e 's/#DEB_HOST_MULTIARCH#/$(DEB_HOST_MULTIARCH)/g' \
		< debian/libtorch-thnn-dev.install.in > debian/libtorch-thnn-dev.install

override_dh_auto_build:
	# build libTHNN.so
	dh_auto_build --buildsystem=cmake -B THNN.build/ --parallel
	# build the rest lua stuff
	dh_auto_build --buildsystem=lua

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	-$(RM) -rf deb.test
	# prepare lua files to launch a "nn.test()"
	set -e; if ! test -d deb.test/nn; then mkdir -p deb.test/nn; fi
	set -e; find . -name '*.so*' -exec cp -v '{}' deb.test/ \;
	set -e; find . -name '*.lua' -exec cp -v '{}' deb.test/nn/ \;
	set -e; cd deb.test; ln -s nn/init.lua nn.lua;
	-set -e; cd deb.test; \
		LD_LIBRARY_PATH=$(ROOTDIR)/deb.test \
		$(LUAJIT) -e "require 'nn'; nn.test();"
	dh_auto_test
endif

override_dh_auto_install:
	# install libTHNN.so
	dh_auto_install --buildsystem=cmake -B THNN.build
	# install the rest lua stuff
	dh_auto_install --buildsystem=lua

override_dh_auto_clean:
	-$(RM) nn THNN_h.lua
	-$(RM) -rf THNN.build 5.1-torch-nn .pc deb.test
	dh_auto_clean

=== debian/tests/control ===
Test-Command: luajit -ltorch -lnn -e 'print(true)'

Test-Command: luajit -ltorch -lnn -e 'nn.test()'

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=0~%cd-g%h, dversionmangle=s/\+dfsg\d*$//" \
https://github.com/torch/nn \
HEAD debian uupdate

## lua-torch-nn 0%7e20161116

=== lib/THNN/CMakeLists.txt ===
--- 
+++ 
@@ -5,14 +5,8 @@
   FIND_PACKAGE(Torch REQUIRED)
 ENDIF()
 
-IF(NOT TH_LIBRARIES)
-  SET(TH_LIBRARIES "TH")
-ENDIF(NOT TH_LIBRARIES)
-MESSAGE(STATUS "TH_LIBRARIES: ${TH_LIBRARIES}")
-
 IF(NOT THNN_INSTALL_LIB_SUBDIR)
   SET(THNN_INSTALL_LIB_SUBDIR "lib" CACHE PATH "THNN install library directory")
-  SET(THNN_INSTALL_INCLUDE_SUBDIR "include" CACHE PATH "THNN install include subdirectory")
 ENDIF()
 
 # Flags
@@ -67,17 +61,6 @@
 SET_TARGET_PROPERTIES(THNN PROPERTIES
   PREFIX "lib"
   IMPORT_PREFIX "lib")
-
-TARGET_LINK_LIBRARIES(THNN ${TH_LIBRARIES})
-
-# Luarocks bug pre-14.04 prevents us from setting it for Lua-Torch
-IF(THNN_SO_VERSION)
-  MESSAGE(STATUS "THNN_SO_VERSION: ${THNN_SO_VERSION}")
-  SET_TARGET_PROPERTIES(THNN PROPERTIES
-    VERSION   ${THNN_SO_VERSION}
-    SOVERSION ${THNN_SO_VERSION})
-ENDIF(THNN_SO_VERSION)
+TARGET_LINK_LIBRARIES(THNN TH)
 
 INSTALL(TARGETS THNN LIBRARY DESTINATION ${THNN_INSTALL_LIB_SUBDIR})
-INSTALL(FILES THNN.h DESTINATION "${THNN_INSTALL_INCLUDE_SUBDIR}/THNN")
-INSTALL(FILES generic/THNN.h DESTINATION "${THNN_INSTALL_INCLUDE_SUBDIR}/THNN/generic")
